Codeforces Round #344 (Div. 2)

2024-01-28 05:58
文章标签 codeforces round div 344

本文主要是介绍Codeforces Round #344 (Div. 2),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

C. Report

注意到每次排序的区间都是某个前缀,如果先排序了短前缀,再排序长前缀,前面的那次排序可以不用做。所以单调栈维护递减序列,排序一次最长前缀,然后逐个视情况(升序还是降序)输出。

#include <bits/stdc++.h>
#include <unordered_map> using namespace std;#define ll long longint a[200010];int ops[200010];
int sta[200010];int k=0;void print(int id,int l,int r){int len=sta[id];if(id+1<k){len-=sta[id+1];if(ops[id] == ops[0]){print(id+1,l,r-len);}else{print(id+1,l+len,r);}}if(ops[id] == ops[0]){for(int i=r-len+1;i<=r;i++){printf("%d ",a[i]);}}else{for(int i=l+len-1;i>=l;i--){printf("%d ",a[i]);}}
}int main(){int n,m;cin>>n>>m;for(int i=0;i<n;i++){scanf("%d",&a[i]);}for(int i=1;i<=m;i++){int op,r;scanf("%d%d",&op,&r);while(k>0 && (sta[k-1]<r)){k--;}ops[k] = op;sta[k] = r;k++;}sort(a,a+sta[0]);if(ops[0]==2){reverse(a,a+sta[0]);}print(0,0,sta[0]-1);for(int i=sta[0];i<n;i++){printf("%d ",a[i]);}return 0;
}

D. Messenger

无聊的题,一看就知道是KMP。通过重复次数*26+原字符,构造出新的“字符”。分类讨论单词长度为1,2和其他情况。

#include <bits/stdc++.h>
#include <unordered_map> using namespace std;#define ll long longconst int maxn = 200010;ll word[maxn];
ll text[maxn];
int _next[maxn];ll textl[maxn];
char textc[maxn];ll wordl[maxn];
char wordc[maxn];int n,m;ll ans = 0;void find_next(){_next[1]=0;int k = 0;for(int i=2;i<=m;i++){while(k && word[i]!=word[k+1]){k = _next[k];}if(word[i]==word[k+1]){_next[i] = ++k;}else{_next[i]=0;}}
}void match(){int k=0;for(int i=1;i<=n;i++){while(k && text[i]!=word[k+1]){k = _next[k];}if(text[i]==word[k+1]){k++;}if(k==m){if(wordc[0]==textc[i-m] && wordl[0]<=textl[i-m] && wordc[m+1]==textc[i+1] && wordl[m+1]<=textl[i+1]){ans++;  }k = _next[k];}}
}int main(){cin>>n>>m;for(int i=1;i<=n;i++){scanf("%I64d-%c",&textl[i],&textc[i]);if(textc[i]==textc[i-1]){textl[i-1]+=textl[i];n--;i--;}text[i] = textl[i]*26LL + textc[i];}for(int i=0;i<m;i++){scanf("%I64d-%c",&wordl[i],&wordc[i]);if(wordc[i]==wordc[i-1]){wordl[i-1]+=wordl[i];m--;i--;}word[i] = wordl[i]*26LL + wordc[i]; }if(m==1){for(int i=1;i<=n;i++){if(textc[i]==wordc[0] && textl[i]>=wordl[0]){ans+=(textl[i]-wordl[0]+1);}}}else if(m==2){for(int i=1;i<n;i++){if(textc[i]==wordc[0] && textl[i]>=wordl[0]){if(textc[i+1]==wordc[1] && textl[i+1]>=wordl[1]){ans++;}}}}else{m-=2;find_next();match();}cout<<ans<<endl;return 0;
}

E. Product Sum

最优解有两种可能,某个字符往右换和往左换,原理是一样的。
不妨考虑往右换的情况,假如我把第 i 个数换到第k个位置,那么答案会增大 (ki)a[i] ,减小 a[i] ~ a[k1] 的和。我们可以枚举需要移动的字符,但是它要移动到哪呢,这可以通过贪心在 log(n) 的时间内找到。方法是逆序枚举,对于当前枚举的 a[i] ,它移动到的最优位置不会超过“之前枚举过的,不小于 a[i] 的最小数”,用map维护每个数的最优移动位置即可解决。用通俗的话讲下原理,因为你要保证移动的数,尽可能大于那些“被迫移动的数”的平均值,两者差越大,这个移动就越赚。

#include <bits/stdc++.h>
#include <unordered_map> using namespace std;#define ll long longint n;
int a[200010];
ll sum[200010];ll ans = 0;void solveR(){map<int,int> mp;for(int i=n;i>=1;i--){auto it = mp.lower_bound(a[i]);int k;if(it==mp.end()){k = n;}else{k = it->second;while(a[k]>a[i]){k--;}}mp[a[i]]=k;ll tmp = (a[i]+0LL)*(k-i) - (sum[k]-sum[i]);ans = max(tmp,ans);}
}void solveL(){map<int,int> mp;for(int i=1;i<=n;i++){auto it = mp.upper_bound(a[i]);int k;if(it==mp.begin()){k = 1;}else{it--;k = it->second;while(a[k]<a[i]){k++;}}mp[a[i]]=k;ll tmp = -(a[i]+0LL)*(i-k) + (sum[i-1]-sum[k-1]);ans = max(tmp,ans);}
}int main(){cin>>n;ll ans0 = 0;for(int i=1;i<=n;i++){scanf("%d",&a[i]);ans0+=(a[i]+0LL)*(i);}//calc sumfor(int i=1;i<=n;i++){sum[i] = sum[i-1] + a[i];}solveR();solveL();cout<<ans+ans0<<endl;return 0;
}

这篇关于Codeforces Round #344 (Div. 2)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/652671

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There